<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/getrandom-0.2.7/src/util_libc.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>util_libc.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="icon" href="https://www.rust-lang.org/favicon.ico"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../getrandom/index.html"><div class="logo-container"><img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk.png" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../getrandom/index.html"><div class="logo-container">
                    <img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk.png" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../getrandom/index.html">
                        <img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk.png" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
</pre><pre class="rust"><code><span class="comment">// Copyright 2019 Developers of the Rand project.</span>
<span class="comment">//</span>
<span class="comment">// Licensed under the Apache License, Version 2.0 &lt;LICENSE-APACHE or</span>
<span class="comment">// https://www.apache.org/licenses/LICENSE-2.0&gt; or the MIT license</span>
<span class="comment">// &lt;LICENSE-MIT or https://opensource.org/licenses/MIT&gt;, at your</span>
<span class="comment">// option. This file may not be copied, modified, or distributed</span>
<span class="comment">// except according to those terms.</span>
<span class="attribute">#![<span class="ident">allow</span>(<span class="ident">dead_code</span>)]</span>
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::Error</span>;
<span class="kw">use</span> <span class="ident">core</span>::{
    <span class="ident">num::NonZeroU32</span>,
    <span class="ident">ptr::NonNull</span>,
    <span class="ident">sync::atomic</span>::{<span class="ident">fence</span>, <span class="ident">AtomicPtr</span>, <span class="ident">Ordering</span>},
};
<span class="kw">use</span> <span class="ident">libc::c_void</span>;

<span class="macro">cfg_if!</span> {
    <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;netbsd&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;openbsd&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;android&quot;</span>))]</span> {
        <span class="kw">use</span> <span class="ident">libc::__errno</span> <span class="kw">as</span> <span class="ident">errno_location</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;linux&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;emscripten&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;redox&quot;</span>))]</span> {
        <span class="kw">use</span> <span class="ident">libc::__errno_location</span> <span class="kw">as</span> <span class="ident">errno_location</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;solaris&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;illumos&quot;</span>))]</span> {
        <span class="kw">use</span> <span class="ident">libc::___errno</span> <span class="kw">as</span> <span class="ident">errno_location</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;macos&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;freebsd&quot;</span>))]</span> {
        <span class="kw">use</span> <span class="ident">libc::__error</span> <span class="kw">as</span> <span class="ident">errno_location</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;haiku&quot;</span>)]</span> {
        <span class="kw">use</span> <span class="ident">libc::_errnop</span> <span class="kw">as</span> <span class="ident">errno_location</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;horizon&quot;</span>, <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;arm&quot;</span>))]</span> {
        <span class="kw">extern</span> <span class="string">&quot;C&quot;</span> {
            <span class="comment">// Not provided by libc: https://github.com/rust-lang/libc/issues/1995</span>
            <span class="kw">fn</span> <span class="ident">__errno</span>() -&gt; <span class="kw-2">*mut</span> <span class="ident">libc::c_int</span>;
        }
        <span class="kw">use</span> <span class="ident">__errno</span> <span class="kw">as</span> <span class="ident">errno_location</span>;
    }
}

<span class="macro">cfg_if!</span> {
    <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;vxworks&quot;</span>)]</span> {
        <span class="kw">use</span> <span class="ident">libc::errnoGet</span> <span class="kw">as</span> <span class="ident">get_errno</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;dragonfly&quot;</span>)]</span> {
        <span class="comment">// Until rust-lang/rust#29594 is stable, we cannot get the errno value</span>
        <span class="comment">// on DragonFlyBSD. So we just return an out-of-range errno.</span>
        <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">get_errno</span>() -&gt; <span class="ident">libc::c_int</span> { <span class="op">-</span><span class="number">1</span> }
    } <span class="kw">else</span> {
        <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">get_errno</span>() -&gt; <span class="ident">libc::c_int</span> { <span class="kw-2">*</span><span class="ident">errno_location</span>() }
    }
}

<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">last_os_error</span>() -&gt; <span class="ident">Error</span> {
    <span class="kw">let</span> <span class="ident">errno</span> <span class="op">=</span> <span class="kw">unsafe</span> { <span class="ident">get_errno</span>() };
    <span class="kw">if</span> <span class="ident">errno</span> <span class="op">&gt;</span> <span class="number">0</span> {
        <span class="ident">Error::from</span>(<span class="ident">NonZeroU32::new</span>(<span class="ident">errno</span> <span class="kw">as</span> <span class="ident">u32</span>).<span class="ident">unwrap</span>())
    } <span class="kw">else</span> {
        <span class="ident">Error::ERRNO_NOT_POSITIVE</span>
    }
}

<span class="comment">// Fill a buffer by repeatedly invoking a system call. The `sys_fill` function:</span>
<span class="comment">//   - should return -1 and set errno on failure</span>
<span class="comment">//   - should return the number of bytes written on success</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">sys_fill_exact</span>(
    <span class="kw-2">mut</span> <span class="ident">buf</span>: <span class="kw-2">&amp;mut</span> [<span class="ident">u8</span>],
    <span class="ident">sys_fill</span>: <span class="kw">impl</span> <span class="ident">Fn</span>(<span class="kw-2">&amp;mut</span> [<span class="ident">u8</span>]) -&gt; <span class="ident">libc::ssize_t</span>,
) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span>(), <span class="ident">Error</span><span class="op">&gt;</span> {
    <span class="kw">while</span> <span class="op">!</span><span class="ident">buf</span>.<span class="ident">is_empty</span>() {
        <span class="kw">let</span> <span class="ident">res</span> <span class="op">=</span> <span class="ident">sys_fill</span>(<span class="ident">buf</span>);
        <span class="kw">if</span> <span class="ident">res</span> <span class="op">&lt;</span> <span class="number">0</span> {
            <span class="kw">let</span> <span class="ident">err</span> <span class="op">=</span> <span class="ident">last_os_error</span>();
            <span class="comment">// We should try again if the call was interrupted.</span>
            <span class="kw">if</span> <span class="ident">err</span>.<span class="ident">raw_os_error</span>() <span class="op">!</span><span class="op">=</span> <span class="prelude-val">Some</span>(<span class="ident">libc::EINTR</span>) {
                <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">err</span>);
            }
        } <span class="kw">else</span> {
            <span class="comment">// We don&#39;t check for EOF (ret = 0) as the data we are reading</span>
            <span class="comment">// should be an infinite stream of random bytes.</span>
            <span class="ident">buf</span> <span class="op">=</span> <span class="kw-2">&amp;mut</span> <span class="ident">buf</span>[(<span class="ident">res</span> <span class="kw">as</span> <span class="ident">usize</span>)..];
        }
    }
    <span class="prelude-val">Ok</span>(())
}

<span class="comment">// A &quot;weak&quot; binding to a C function that may or may not be present at runtime.</span>
<span class="comment">// Used for supporting newer OS features while still building on older systems.</span>
<span class="comment">// Based off of the DlsymWeak struct in libstd:</span>
<span class="comment">// https://github.com/rust-lang/rust/blob/1.61.0/library/std/src/sys/unix/weak.rs#L84</span>
<span class="comment">// except that the caller must manually cast self.ptr() to a function pointer.</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Weak</span> {
    <span class="ident">name</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> <span class="ident">str</span>,
    <span class="ident">addr</span>: <span class="ident">AtomicPtr</span><span class="op">&lt;</span><span class="ident">c_void</span><span class="op">&gt;</span>,
}

<span class="kw">impl</span> <span class="ident">Weak</span> {
    <span class="comment">// A non-null pointer value which indicates we are uninitialized. This</span>
    <span class="comment">// constant should ideally not be a valid address of a function pointer.</span>
    <span class="comment">// However, if by chance libc::dlsym does return UNINIT, there will not</span>
    <span class="comment">// be undefined behavior. libc::dlsym will just be called each time ptr()</span>
    <span class="comment">// is called. This would be inefficient, but correct.</span>
    <span class="comment">// TODO: Replace with core::ptr::invalid_mut(1) when that is stable.</span>
    <span class="kw">const</span> <span class="ident">UNINIT</span>: <span class="kw-2">*mut</span> <span class="ident">c_void</span> <span class="op">=</span> <span class="number">1</span> <span class="kw">as</span> <span class="kw-2">*mut</span> <span class="ident">c_void</span>;

    <span class="comment">// Construct a binding to a C function with a given name. This function is</span>
    <span class="comment">// unsafe because `name` _must_ be null terminated.</span>
    <span class="kw">pub</span> <span class="kw">const</span> <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">new</span>(<span class="ident">name</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> <span class="ident">str</span>) -&gt; <span class="self">Self</span> {
        <span class="self">Self</span> {
            <span class="ident">name</span>,
            <span class="ident">addr</span>: <span class="ident">AtomicPtr::new</span>(<span class="ident"><span class="self">Self</span>::UNINIT</span>),
        }
    }

    <span class="comment">// Return the address of a function if present at runtime. Otherwise,</span>
    <span class="comment">// return None. Multiple callers can call ptr() concurrently. It will</span>
    <span class="comment">// always return _some_ value returned by libc::dlsym. However, the</span>
    <span class="comment">// dlsym function may be called multiple times.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">ptr</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">NonNull</span><span class="op">&lt;</span><span class="ident">c_void</span><span class="op">&gt;</span><span class="op">&gt;</span> {
        <span class="comment">// Despite having only a single atomic variable (self.addr), we still</span>
        <span class="comment">// cannot always use Ordering::Relaxed, as we need to make sure a</span>
        <span class="comment">// successful call to dlsym() is &quot;ordered before&quot; any data read through</span>
        <span class="comment">// the returned pointer (which occurs when the function is called).</span>
        <span class="comment">// Our implementation mirrors that of the one in libstd, meaning that</span>
        <span class="comment">// the use of non-Relaxed operations is probably unnecessary.</span>
        <span class="kw">match</span> <span class="self">self</span>.<span class="ident">addr</span>.<span class="ident">load</span>(<span class="ident">Ordering::Relaxed</span>) {
            <span class="ident"><span class="self">Self</span>::UNINIT</span> =&gt; {
                <span class="kw">let</span> <span class="ident">symbol</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">name</span>.<span class="ident">as_ptr</span>() <span class="kw">as</span> <span class="kw-2">*const</span> <span class="kw">_</span>;
                <span class="kw">let</span> <span class="ident">addr</span> <span class="op">=</span> <span class="kw">unsafe</span> { <span class="ident">libc::dlsym</span>(<span class="ident">libc::RTLD_DEFAULT</span>, <span class="ident">symbol</span>) };
                <span class="comment">// Synchronizes with the Acquire fence below</span>
                <span class="self">self</span>.<span class="ident">addr</span>.<span class="ident">store</span>(<span class="ident">addr</span>, <span class="ident">Ordering::Release</span>);
                <span class="ident">NonNull::new</span>(<span class="ident">addr</span>)
            }
            <span class="ident">addr</span> =&gt; {
                <span class="kw">let</span> <span class="ident">func</span> <span class="op">=</span> <span class="ident">NonNull::new</span>(<span class="ident">addr</span>)<span class="question-mark">?</span>;
                <span class="ident">fence</span>(<span class="ident">Ordering::Acquire</span>);
                <span class="prelude-val">Some</span>(<span class="ident">func</span>)
            }
        }
    }
}

<span class="macro">cfg_if!</span> {
    <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;linux&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;emscripten&quot;</span>))]</span> {
        <span class="kw">use</span> <span class="ident">libc::open64</span> <span class="kw">as</span> <span class="ident">open</span>;
    } <span class="kw">else</span> {
        <span class="kw">use</span> <span class="ident">libc::open</span>;
    }
}

<span class="comment">// SAFETY: path must be null terminated, FD must be manually closed.</span>
<span class="kw">pub</span> <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">open_readonly</span>(<span class="ident">path</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">libc::c_int</span>, <span class="ident">Error</span><span class="op">&gt;</span> {
    <span class="macro">debug_assert_eq!</span>(<span class="ident">path</span>.<span class="ident">as_bytes</span>().<span class="ident">last</span>(), <span class="prelude-val">Some</span>(<span class="kw-2">&amp;</span><span class="number">0</span>));
    <span class="kw">loop</span> {
        <span class="kw">let</span> <span class="ident">fd</span> <span class="op">=</span> <span class="ident">open</span>(<span class="ident">path</span>.<span class="ident">as_ptr</span>() <span class="kw">as</span> <span class="kw-2">*const</span> <span class="kw">_</span>, <span class="ident">libc::O_RDONLY</span> <span class="op">|</span> <span class="ident">libc::O_CLOEXEC</span>);
        <span class="kw">if</span> <span class="ident">fd</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">0</span> {
            <span class="kw">return</span> <span class="prelude-val">Ok</span>(<span class="ident">fd</span>);
        }
        <span class="kw">let</span> <span class="ident">err</span> <span class="op">=</span> <span class="ident">last_os_error</span>();
        <span class="comment">// We should try again if open() was interrupted.</span>
        <span class="kw">if</span> <span class="ident">err</span>.<span class="ident">raw_os_error</span>() <span class="op">!</span><span class="op">=</span> <span class="prelude-val">Some</span>(<span class="ident">libc::EINTR</span>) {
            <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">err</span>);
        }
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="getrandom" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>